﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Microsoft.Practices.Prism.Events;
using Microsoft.Practices.Prism.Regions;
using Prism.Example.Events;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Prism.Example
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class Shell : Page
    {
        private readonly IEventAggregator _eventAggregator;
        public Shell(IRegionManager regionManager, IEventAggregator eventAggregator)
        {
            this.InitializeComponent();
            RegionManager.SetRegionManager(this.titleContent, regionManager);
            RegionManager.SetRegionName(this.titleContent, RegionNames.MainRegion);

            _eventAggregator = eventAggregator;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            _eventAggregator.GetEvent<OnChangeViewEvent>().Publish("Page1");

        }
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            _eventAggregator.GetEvent<OnChangeViewEvent>().Publish("View1");
        }
    }
}
